#!/bin/bash

###########################
# mp3-genre-group.sh v0.1 #
###########################
#
# This little thingy will change the group of the dir to that of the genre
# listed in the .message-file made by zipscript-c.
# Run in crontab or whatever.
# Meant to work with mp3-dirs, ofcourse.
# As always, my script has been tested with freebsd 4.4/4.5, and comes with
# no guarantees.
#
# Yes, I know this script suffers from a "bad name", like the rest of my
# script. Who cares! ;)

##########################################
# The config - change to the appropriate #
##########################################

# Your GLFTPD root-dir
glftpd_dir="/glftpd"

# Where do you keep your MP3's?
glftpd_mp3="/site/MP3"

# The name of your dated dir. Don't worry - it will work with non-dated dirs
# as well. BUT KEEP THE SLASH IN FRONT!
# A future release might add more than one dir.. stay tuned.
today_dir="/%m%d"

#################
# End of Config #
#################

# no need to change below

grp_largest="100"
work_dir="$glftpd_dir""$glftpd_mp3""`date +"$today_dir"`"
for dir in `ls -1FP $work_dir`; do
 if [ -d $work_dir/$dir ]; then
  if [ -e $work_dir/$dir/.message ]; then
    genre="`cat $work_dir/$dir/.message | grep "Genre : " | { read genre colon name trash; echo $name; };`"
  echo "$genre : $dir" >> $work_dir/.message.temp
  else
    for subdir in `ls -1FP $work_dir/$dir`; do
      if [ "`echo $subdir | grep "/"`" != "" ]; then
        if [ -e $work_dir/$dir/$subdir/.message ]; then
          genre="`cat $work_dir/$dir/$subdir/.message | grep "Genre : " | { read genre colon name trash; echo $name; };`"
          echo "$genre : $dir" >> $work_dir/.message.temp
        else
          nochange=1
        fi
      else
        nochange=1
      fi
    done
  fi
  if [ "`cat $glftpd_dir/etc/group | grep $genre`" = "" ]; then
    for grp in `cat $glftpd_dir/etc/group | sed "s/ /_/g"`; do
      grp_string=`echo "$grp" | sed "s/::/: comment :/g"`
      grp_string=`echo "$grp_string" | sed "s/:/ : /g"`
      grp_string=`echo "$grp_string" | { read groupname colon_1 comment colon_2 gid trash; echo $gid; };`
      if [ ! $grp_string -lt $grp_largest ]; then
        grp_largest=$grp_string
      fi
    done
    grp=`expr $grp_largest \+ 100`
    echo "$genre:$MP3:$grp:" >> $glftpd_dir/etc/group
    echo "$genre:$MP3:$grp:" >> $glftpd_dir/etc/group-
    chgrp -P $grp $work_dir/$dir
  else
    grp="`cat $glftpd_dir/etc/group | grep $genre | sed "s/ /_/g" | sed "s/::/: comment :/g" | sed "s/:/ : /g" | { read groupname colon_1 comment colon_2 gid trash; echo $gid; };`"
    chgrp -P $grp $work_dir/$dir
    nochange=1
  fi
 fi
done
if [ -e $work_dir/.message.temp ]; then
  cat $work_dir/.message.temp | sort -n > $work_dir/.message
  rm $work_dir/.message.temp
else
  nochange=1
fi

